//  LIMedia.m
//  THIS IS THE SPECIAL SPOTLIGHT-ONLY VERSION OF THIS CLASS. IT IS NOT FULLY FUNCTIONAL. DO NOT CONFUSE IT WITH THE REAL FILE.

#import "LIMedia.h"

#import "DMCommonMacros.h"
#import "LibraryCoreDataAttributeKeys.h"
#import "LILoan.h"
#import "LICoverImageManagedObject.h"
#import "NSString-DMExtensions.h"


@implementation LIMedia

#pragma mark NSObject (NSKeyValueCoding Protocol)

- (id)valueForUndefinedKey:(NSString *)key;
{
    return nil;
}


#pragma mark CoreData

@dynamic uuidString; // from LIAbstractManagedObject, normally, but we don't have that in our special Spotlight version


#pragma mark API

// Special computed attributes for Spotlight attributes

- (NSString *)displayName;
{
    // Display name
    NSString *title = self.title;
    NSArray *authorsList = [self.creatorsCompositeString componentsSeparatedByString:@"\n"];
    NSString *firstAuthor = ([authorsList count] > 0) ? [authorsList objectAtIndex:0] : nil;
    
    if (!IsEmpty(title) && !IsEmpty(firstAuthor))
        return [NSString stringWithFormat:@"%@: %@", title, firstAuthor];
    else if (!IsEmpty(title) && IsEmpty(firstAuthor))
        return title;
    else if (!IsEmpty(firstAuthor))
        return firstAuthor;
    else
        return NSLocalizedString(@"untitled", @"display name of items with no title or author");
}

- (float)durationSeconds;
{
    return [[self valueForKey:LIMediaMinutesAttributeKey] floatValue] * 60.0;
}

- (BOOL)hasLoan;
{
    return [self valueForKey:LIMediaLoanRelationshipKey] != nil;
}

- (NSArray *)keywords;
// LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE LOCALIZE  
// LOCALIZE LOCALIZE this whole method needs to be localized
{
    NSMutableSet *keywords = [NSMutableSet set];
    
    // Medium type keywords
    NSDictionary *mediumTypeWords = [NSDictionary dictionaryWithObjectsAndKeys:
                                     [NSArray arrayWithObjects:@"book", @"books", nil], LIBookMediumType,
                                     [NSArray arrayWithObjects:@"movie", @"movies", @"film", @"films", @"flick", @"flicks", @"video", @"videos", @"talky", @"talkies", nil], LIMovieMediumType,
                                     [NSArray arrayWithObjects:@"music", nil], LIMusicMediumType,
                                     [NSArray arrayWithObjects:@"video", @"games", @"game", @"videogame", @"videogames", nil], LIVideoGameMediumType,
                                     [NSArray arrayWithObjects:@"software", @"warez", @"program", @"programs", @"application", @"applications", nil], LISoftwareMediumType,
                                     [NSArray arrayWithObjects:@"tool", @"tools", nil], LIToolMediumType,
                                     [NSArray arrayWithObjects:@"toy", @"toys", @"boardgame", @"boardgames", @"game", @"games", nil], LIToyMediumType,
                                     [NSArray arrayWithObjects:@"electronics", @"gadget", @"gadgets", nil], LIGadgetMediumType,
                                     [NSArray arrayWithObjects:@"clothing", @"clothes", @"apparel", nil], LIApparelMediumType,
                                     nil];
    
    NSArray *typeSynonyms = [mediumTypeWords objectForKey:self.type];
    if (!IsEmpty(typeSynonyms))
        [keywords addObjectsFromArray:typeSynonyms];
    
    // 'Format' keyword, followed by 's' so users can search for "DVDs" (English-only hack)
    NSString *format = [self valueForKey:LIMediaFormatStringAttributeKey];
    if (!IsEmpty(format))
        [keywords addObject:[format stringByAppendingString:@"s"]]; // this hack only works in English, but it doesn't hurt other languages (I hope)
    
    // Is loaned out?
    if ([self hasLoan])
        [keywords addObjectsFromArray:[NSArray arrayWithObjects:@"checked", @"out", @"checkedout", @"checked-out", @"borrowed", @"loaned", @"loans", @"lent", nil]];
    
    // Is used?
    if ([[self valueForKey:LIMediaUsedAttributeKey] boolValue])
        [keywords addObjectsFromArray:[NSArray arrayWithObjects:@"used", @"second-hand", nil]];
    
    // Is experienced?
    if ([[self valueForKey:LIMediaHasExperiencedAttributeKey] boolValue]) {
        NSDictionary *experiencedMediumWords = [NSDictionary dictionaryWithObjectsAndKeys:
                                                [NSArray arrayWithObjects:@"experienced", @"read", @"finished", @"completed", nil], LIBookMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"viewed", @"played", @"watched", @"seen", nil], LIMovieMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"listened", @"heard", @"played", nil], LIMusicMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"played", nil], LIVideoGameMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"run", nil], LISoftwareMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"utilized", nil], LIToolMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"played", nil], LIToyMediumType,
                                                [NSArray arrayWithObjects:@"experienced", @"utilized", nil], LIGadgetMediumType,
                                                [NSArray arrayWithObjects:@"worn", nil], LIApparelMediumType,
                                                nil];
        
        // Get keywords for this medium type
        NSArray *experiencedWords = [experiencedMediumWords objectForKey:self.type];
        if (experiencedWords)
            [keywords addObjectsFromArray:experiencedWords];
    }
    
    // Is rare?
    if ([[self valueForKey:LIMediaRareAttributeKey] boolValue])
        [keywords addObject:@"rare"];
    // Is signed?
    if ([[self valueForKey:LIMediaIsSignedAttributeKey] boolValue])
        [keywords addObject:@"signed"];
    
    return [keywords allObjects];
}

- (NSString *)loanBorrowerName;
{
    return [self.loan.borrower name];
}

- (NSString *)truncatedPlainTextDescription;
{
    NSString *htmlString = [self.userSynopsis valueForKey:@"htmlString"];
    if (!htmlString.length)
        return nil;
    
    NSError *error = nil;
    NSAttributedString *attributedString = [[[NSAttributedString alloc] initWithData:[htmlString dataUsingEncoding:NSUTF8StringEncoding] options:[NSDictionary dictionaryWithObject:NSHTMLTextDocumentType forKey:NSDocumentTypeDocumentAttribute] documentAttributes:NULL error:&error] autorelease];
    if (error || !attributedString.length)
        return nil;
    
    // Truncate the description if necessary (Spotlight does a reasonable job at this, but Finder's Info panel doesn't even try)
    NSString *plainDescription = [[attributedString string] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
#define MAX_DESCRIPTION_LENGTH (300)
    if ([plainDescription length] > MAX_DESCRIPTION_LENGTH)
        plainDescription = [[plainDescription substringWithRange:NSMakeRange(0, MAX_DESCRIPTION_LENGTH)] stringByAppendingString:@"..."];
    
    return plainDescription;
}

@end


NSString *LIAbstractManagedObjectUUIDStringAttributeKey = @"uuidString";